package test.drs_tst.recs.plugins.energy;

import java.io.FileNotFoundException;
import java.io.IOException;

import schedframe.resources.computing.Node;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.profiles.energy.ResourceEvent;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;
import test.drs_tst.recs.utils.appprofiles.ApplicationProfileBase;
import test.drs_tst.recs.utils.appprofiles.ProfileGetter;

public class AmdNodeEEP extends RecsNodeBaseEEP {

	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double powerConsumption = 0;
		
		Node node = (Node) resource;
		try {
			if(jobRegistry.getRunningTasks().size() > 0) {
				powerConsumption = powerConsumption + getMeasuredPower(createQuery(jobRegistry.getRunningTasks().get(0)));
			}
			else {
				for(Processor cpu: node.getProcessors()){
					try{
						//powerConsumption = powerConsumption + cpu.getPowerInterface().getRecentPowerUsage().getValue();
					} catch (Exception e){
						
					}
				}
				try {
					powerConsumption = powerConsumption + node.getPowerInterface().getPowerConsumption(node.getPowerInterface().getPowerState());
				} catch (NoSuchFieldException e) {
				}
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return powerConsumption;
	}
	
	protected ApplicationProfileBase getProfile(String name){
		ApplicationProfileBase profile = ProfileGetter.getProfileWithName(name);
		profile.setGetDefault(true);
		return profile;
	}

}
